##############################################################################
=pod

=head1 NAME

Gui module

=head1 DESCRIPTION

Module containing GUI related functions

=head1 COPYRIGHT and LICENCE

Copyright (c) 2002 Bruno Boettcher

Gui.pm is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; version 2 of the License.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

=head1 Methods of this class

=over

=cut

##############################################################################



package zebot::gui::Gui;
use strict;

		
		
package Gtk2::ListStore;

##############################################################################
=pod

=item remove_item

facility function to remove a given item from a ListStore

=cut

##############################################################################

sub remove_item {
	my $self = shift;
	my($item) = @_;

	my $iter = $self->get_iter_first;
	do {
		my $v = $self->get_value($iter, 0);
		$self->remove($iter), return if($v eq $item);
	} while($iter = $self->iter_next($iter));
}

1;
